var gulp   = require('gulp');
var glob   = require('glob');
var path   = require('path');
var fs     = require('fs');
var gutil  = require('gulp-util');
var config = require('../config');
var chalk  = require('chalk');

gulp.task('collect:js', function (done) {
    var files = glob.sync('src/ext/*/components/register.js');
    var lines = [
        '/**',
        ' * This file is generated by gulp collect:js task, do not edit',
        ' */'
    ];

    files.forEach(function (file) {
        lines.push('require(\'.' + path.sep + path.relative('src/ext', file) + '\');');
    });

    fs.writeFile('src/ext/collected.js', lines.join('\n'), function (err) {
        if (err) { throw err; }
    });

    done();
});


/**
 * Collect extensions styles looking in modules with name matching mozaik-ext-*
 */
gulp.task('collect:styl', function (done) {
    gutil.log(chalk.green('Collecting extensions styles'));

    var files = glob.sync(config.root + 'node_modules/mozaik-ext-*/**/index.styl');

    var lines = [
        '/**',
        ' * This file is generated by gulp collect:styl task, do not edit',
        ' */'
    ];

    files.forEach(function (file) {
        lines.push('@require "' + path.relative(config.mozaikSrc + 'ext', file) + '";');
    });

    fs.writeFile(config.mozaikLib + 'ext/collected.styl', lines.join('\n'), function (err) {
        if (err) {
            throw err;
        }
    });

    done();
});